<?php
///////////////////////////////////////////////////////// 
//      Этот плагин сгенерирован автоматически     	   // 
//      генератор написал stroller7@gmail.com		   // 
///////////////////////////////////////////////////////// 

class p_happy_Birthday extends cmsPlugin { 

// ==================================================================== // 

	public function __construct(){ 

		 

		// Информация о плагине
		$this->info['plugin']          	= 'p_happy_Birthday';
		$this->info['title']       		= 'C днем рождения!';
		$this->info['description']     	= 'Добавляет на стену пользователя поздравление с днем рождения';
		$this->info['author']      		= 'stroller7@gmail.com';
		$this->info['version']     		= '1.0'; 

        global $_LANG;
		
		// Настройки по-умолчанию
        // Ключи массива должны быть латиницей в верхнем регистре
        // если вы хотите, чтобы название опций было на нужном вам языке
        // создайте соответствующий lang файл, например /languages/ru/plugins/p_happy_Birthday.php
        // ключи языковых переменных должны совпадать с ключами массива конфигурации
		// добавьте после следующей строчки еще, если нужно
		
		$this->config['PLUGIN_GREETING_TEXT']  		=  $_LANG['GREETING_TEXT'];  
		$this->config['PLUGIN_GREETING_AUTHOR']  	=  $_LANG['GREETING_AUTHOR'];
		$this->config['PLUGIN_GREETING_TIME']  		=  '8:00';
		$this->config['PLUGIN_IMAGES']  			=  '/plugins/p_happy_Birthday/images/';
		$this->config['PLUGIN_GREETING_WALL_DIV']	=  '';
		$this->config['PLUGIN_GREETING_IMAGE_DIV']	=  '';
		$this->config['PLUGIN_IMAGE_CSS']  			=  'width: 50%';
		$this->config['PLUGIN_GREETING_TEXT_CSS']  	=  'font: bold normal 1.1em serif; color: #0033CC';
		$this->config['PLUGIN_GREETING_AUTHOR_CSS'] =  'font: bold italic 1.2em arial; color: #FF0066';


		// События, которые будут отлавливаться плагином. 
		$this->events[]                 = 'HAPPY_BIRTHDAY'; 

	parent::__construct();	
	} 


// ==================================================================== // 

	 /**
     * Процедура установки плагина
     * @return bool
     */ 
	 public function install(){
		return parent::install();
	} 


// ==================================================================== // 

	 /**
     * Процедура обновления плагина
     * @return bool
     */
    public function upgrade(){
		return parent::upgrade();
	} 


// ==================================================================== // 

	/**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
	 public function execute($event='', $item=array()){
		parent::execute();
		// если событий, обрабатываемых плагином несколько, добавьте строчку case в этот оператор switch
		// не забудьте, что каждая строчка вызывает свой индивидуальный метод! 
		// эти методы вы описали в поле Методы, когда использовали утилиту
		switch ($event){ 
			case 'HAPPY_BIRTHDAY': $item = $this->happyBirthday($item); break; 

		}
		return $item;
	 } 


	
// ==================================================================== // 

	// Здесь тело метода, вызываемого оператором switch
	private function happyBirthday($item) { 
		
		global $_LANG;

		// Выбираю случайную картинку из папки images плагина
		$path = PATH.$this->config['PLUGIN_IMAGES'];
		$files = glob($path.'*.*');
				if (count($files) > 0){
					foreach ($files as $file){      
						if (file_exists($file)){
							$file_list[] = str_replace($path, '', $file);
						}   
					}
				}		
		$image_keys = array_rand($file_list);
		$picture = $file_list[$image_keys]; 
			
		// Составляю текст сообщения
		$content = 	'<div style="'.$this->config['PLUGIN_GREETING_WALL_DIV'].'">'.
						'<div style="'.$this->config['PLUGIN_GREETING_IMAGE_DIV'].'">'.
							'<img src="'.$this->config['PLUGIN_IMAGES'].$picture.'" alt="Happy Birthday" style="'.$this->config['PLUGIN_IMAGE_CSS'].'" />'.
						'</div>'.
						'<div style="'.$this->config['PLUGIN_GREETING_TEXT_CSS'].'" >'.
							$this->config['PLUGIN_GREETING_TEXT'].
						'</div>'.
						'<div style="'.$this->config['PLUGIN_GREETING_AUTHOR_CSS'].'" >'.
							$this->config['PLUGIN_GREETING_AUTHOR'].
						'</div>'.
					'</div>';

		// Получаю час и минуту для записи на стену
		$time = explode(':', $this->config['PLUGIN_GREETING_TIME']);
		$hour = $time[0];
		$minute = $time[1];
		// Получаю метки времени:
		// начала текущих суток, 
		$mkstart = mktime(0, 0, 0, date("m"), date("d"), date("Y"));
		// конца текущих суток, 
		$mkfinish = mktime(23, 59, 59, date("m"), date("d"), date("Y"));
		// метка, когда надо вставить поздравление на стену
		$mkpost = mktime($hour, $minute, 0, date("m"), date("d"), date("Y"));
		
		// Формат лога:
		// метка времени | id имениника | login имениника
		// Путь к логу
		$log_path = '/plugins/p_happy_Birthday/timer/timer.log';
		
		// Просматриваю лог и удаляю все старые записи (больше суток)
		$lines = file(PATH.$log_path);
		foreach($lines as $n=>$line){
			$item = explode(' | ', rtrim($line));
			if($line == ''){unset($lines[$n]);}
			if($item[0] < $mkstart){unset($lines[$n]);}
		}
		// Записываю лог обратно
		$fd = fopen(PATH.$log_path, "w");
		foreach($lines as $line){
			fwrite($fd, $line."\r\n");
		}
		fclose($fd);
		
		// Просматриваю лог на предмет записей
		$lines = file(PATH.$log_path);
		foreach($lines as $n=>$line){
			if($line){$item = explode(' | ', rtrim($line));	}
				if($item[0]){$record[$item[1]] = 1;}else{$record[$item[1]] = 0;}
		}
	
		// Получаю именников, если наступило время поздравления и запись о поздравлении отсутствует в логе
		if(time() > $mkpost && !$record){
			$now = date("Y-m-d H:i:s");		
			$sql = "SELECT id, login FROM `cms_users` WHERE DAY(birthdate)=DAY(CURDATE()) && MONTH(birthdate)=MONTH(CURDATE()) ";
			$result = $this->inDB->query($sql);
			if ($this->inDB->num_rows($result)){
				while($notation = $this->inDB->fetch_assoc($result)){
					$birthday_list[] = $notation;
				}
			}
			// Вставляю имениникам запись в стену
			foreach($birthday_list as $user){
				if(!$record[$user['id']]){
					$this->inDB->insert('cms_user_wall', array('user_id'=>$user['id'], 'author_id'=>1, 'pubdate'=>$now, 'content'=>$content, 'usertype'=>'users'));		
				}
			}
		}
		// Записываю именников в лог
		if($birthday_list){
			$fd = fopen(PATH.$log_path, "a");
			foreach($birthday_list as $user){
				$item = array(0=>time(), 1=>$user['id'], 2=>$user['login']);
				$string = implode(' | ', $item);
				fwrite($fd, $string."\r\n");
			}
			fclose($fd);
		}
			
		return $item;
	}
	
// ==================================================================== // 

}
?>
	